import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import {AlertController } from '@ionic/angular';
import {SharedService} from 'src/modules/user/service-user/Share.service'
import * as Parse from "parse"
(Parse as any).serverURL = "https://web2023.fmode.cn/parse"
Parse.initialize("dev")

interface Contact {
  name: string;
  avatar: string;
}

@Component({
  selector: 'app-friends',
  templateUrl: './friends.page.html',
  styleUrls: ['./friends.page.scss'],
})
export class FriendsPage implements OnInit {


  userId :any = '';
  cares :any = [];

  contacts: Contact[] = [
    { name: '张三', avatar: 'https://via.placeholder.com/150' },
    { name: '李四', avatar: 'https://via.placeholder.com/150' },
    { name: '王五', avatar: 'https://via.placeholder.com/150' },
    { name: '姜皓天', avatar: 'https://ts4.cn.mm.bing.net/th?id=OIP-C.YPJu6C_sxopQW7griUsdjwHaLH&w=204&h=306&c=8&rs=1&qlt=90&o=6&pid=3.1&rm=2' },
  ];

  ngOnInit() {
    this.userId=this.sharedService.getUserId()
    this.findMyCare()
  }
  constructor(private sharedService: SharedService,private router:Router,private alertCtrl:AlertController){
    
    this.userId=this.sharedService.getUserId()
    console.log(this.userId)
    // findMyCare(this.userId,this.cares)
    // console.log(this.cares)
  }

  async findMyCare() {
    console.log(this.userId)
    const GzpCare = Parse.Object.extend('GzpCare')
    const query = new Parse.Query(GzpCare);
    query.equalTo("userId", this.userId);
    try {
      const Cares = await query.find();
      for (const care of Cares) {
        this.cares.push({
          careUserId:care.get("careUserId"),
          careUsername:care.get('careUsername'),
          careUserImg:"http://q1.qlogo.cn/g?b=qq&nk="+care.get("careUserId")+"&s=100"
        }) 
      }
    } catch (error) {
      console.error("查询消息时出错：", error);
    }
  }

  async noCareThis(care: any) {
    if (this.userId != null) {
      const GzpCare = Parse.Object.extend('GzpCare');
      const query = new Parse.Query(GzpCare);
      query.equalTo("userId", this.userId);
      query.equalTo("careUserId", care.careUserId);
      query.equalTo("careUsername", care.careUsername);
      const noCare = await query.find();
      for (const obj of noCare) {
        await obj.destroy();
      }
      const alert =  await this.alertCtrl.create({
        header: '取关成功',
        subHeader: '该用户已不是你的关注用户',
        buttons: ['好的'],
      });
      await alert.present();
      this.cares=[]
      this.findMyCare()
    }
  }
  goChatPage(){
    this.router.navigate(["..//chat-page"],{
    })
  }
  goAiChatPage(){
    this.router.navigate(["./homepage/ai-chat"],{
    })
  }
  // public data = [
  //   'Amsterdam',
  //   'Buenos Aires',
  //   'Cairo',
  //   'Geneva',
  //   'Hong Kong',
  //   'Istanbul',
  //   'London',
  //   'Madrid',
  //   'New York',
  //   'Panama City',
  // ];
  showDropdown = false;
  public results = [...this.contacts];

  handleInput(event: any) {
    const query = event.target.value.toLowerCase();
    this.results = this.contacts.filter((d) => d.name.toLowerCase().indexOf(query) > -1);
  }

  deleteContact(contact: Contact): void {
    const index = this.contacts.indexOf(contact);
    if (index > -1) {
      this.contacts.splice(index, 1);
    }
  }

  pinContact(contact: Contact): void {
    const index = this.contacts.indexOf(contact);
    if (index > -1) {
      const [removed] = this.contacts.splice(index, 1);
      this.contacts.unshift(removed);
    }
  }
  toggleDropdown(){
    this.showDropdown=true
  }
  
}
