import {  OnInit } from '@angular/core';
import {NavController } from '@ionic/angular';
import { Component, HostListener , ElementRef, } from '@angular/core';
import { Router } from '@angular/router';

import * as Parse from "parse"
(Parse as any).serverURL = "https://web2023.fmode.cn/parse"
Parse.initialize("dev")

// 获取数据库的内容
function getScenic() {
  const GzpScenicSpot = Parse.Object.extend('GzpScenicSpot');
  const query = new Parse.Query(GzpScenicSpot);
  return query.find().then(
    (results) => {
      return results.map((result) => result.toJSON());
    },
    (error) => {
      console.error('Error:', error);
      return [];
    }
  );
}

@Component({
  selector: 'app-trave',
  templateUrl: './trave.page.html',
  styleUrls: ['./trave.page.scss'],
})
export class TravePage implements OnInit {

  ngOnInit() {
  }

  back(){
    this.navCtrl.back()
  }
  scenicSpots: any[] = [];
  isExpanded: boolean = false;

  constructor(private elementRef: ElementRef ,private router:Router,private navCtrl:NavController,) {
    this.fetchData();
  }

  fetchData() {
    getScenic().then((scenicSpots) => {
      this.scenicSpots=scenicSpots;
    });
  }
  
// 搜索栏
  @HostListener('document:click', ['$event.target'])
  onClick(target: any) {
    const clickedInside = this.elementRef.nativeElement.contains(target);
    if (!clickedInside) {
      this.isExpanded = false;
    }
  }

  expandSearch() {
    this.isExpanded = true;
  }
  
  icons = [
    { name: '门票', imageUrl: 'assets/门票.png' },
    { name: '住宿', imageUrl: 'assets/旅游酒店.png' },
    { name: '公交', imageUrl: 'assets/旅游车.png' },
    { name: '美食', imageUrl: 'assets/美食.png' },
    { name: '导航', imageUrl: 'assets/导航.png' },
    { name: '推荐', imageUrl: 'assets/旅游攻略.png' },
    { name: '投诉', imageUrl: 'assets/投诉举报.png' },
    // Add more icons as needed
  ];
  goDetailPage(spot:Parse.Object){
    this.router.navigate(["/pocket-local/homepage/detail-page"],{
      queryParams:spot
    })
  }
}
